<template>
  <v-fade-transition>
    <svn-pro-button
      :text="text"
      :rounded="getRounded()"
      :color="getColor()"
      :variant="getVariant()"
      :icon="extended ? undefined : icon"
      elevation="4"
      :prepend-icon="icon ? icon : undefined"
      :width="extended ? undefined : size === 'small' ? 40 : size === 'large' ? 96 : 56"
      :height="extended ? 56 : size === 'small' ? 40 : size === 'large' ? 96 : 56"
      @click="toTop ? goToTop() : clicked()"
      :class="[(toTop && alignTop) || extended ? '' : 'hidden']"
    />
  </v-fade-transition>
</template>

<script setup>
import SvnProButton from './SvnProButton.vue';
import { ref, onMounted, onUnmounted } from 'vue';

const props = defineProps({
  text: {
    type: String,
    default: 'Label',
  },
  variant: {
    type: String,
    default: 'surface',
  },
  icon: {
    type: String,
    default: 'mdi-plus',
  },
  size: {
    type: String,
    default: 'default',
  },
  extended: {
    type: Boolean,
    default: false,
  },
  toTop: {
    type: Boolean,
    default: false,
  },
  pageRatioDisplay: {
    type: Number,
    default: 4,
  },
  scrollContainerId: {
    type: String,
    default: '', // Optional id of the scrollable container
  },
});

const alignTop = ref(false);
const emit = defineEmits(['click']);
let scrollContainer = null;

onMounted(() => {
  scrollContainer = props.scrollContainerId
    ? document.getElementById(props.scrollContainerId)
    : null;

  // Add scroll event listener to the container if it exists, otherwise to window
  const target = scrollContainer || window;
  target.addEventListener('scroll', alignFunc);
});

onUnmounted(() => {
  const target = scrollContainer || window;
  target.removeEventListener('scroll', alignFunc);
});

const goToTop = () => {
  const target = scrollContainer || window;
  target.scrollTo({ top: 0, left: 0, behavior: 'smooth' });
};

const clicked = () => {
  emit('click');
};

const getRounded = () => {
  return props.extended ? 'pill' : 'circle';
};

const getColor = () => {
  if (props.variant === 'surface') {
    return 'primary';
  } else if (props.variant === 'primary') {
    return 'primary';
  } else if (props.variant === 'secondary') {
    return 'secondary';
  } else {
    return 'primary';
  }
};

const getVariant = () => {
  if (props.variant === 'surface') {
    return 'tonal';
  } else if (props.variant === 'primary') {
    return 'elevated';
  } else if (props.variant === 'secondary') {
    return 'elevated';
  } else {
    return 'tonal';
  }
};

// Align function to detect scroll position in the container or document body
const alignFunc = () => {
  let scrollTop, innerHeight;

  if (scrollContainer) {
    // If the scrollable container exists, get its scroll values
    scrollTop = scrollContainer.scrollTop;
    innerHeight = scrollContainer.clientHeight;
  } else {
    // Fallback to document scrolling
    scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
    innerHeight = window.innerHeight;
  }

  // Adjust the alignTop value based on scroll position
  alignTop.value = scrollTop > innerHeight / props.pageRatioDisplay;
};
</script>